# Create your views here.
import os
import time
import cx_Oracle
from django.http import HttpResponse
from django.views.decorators.csrf import csrf_exempt
from rest_framework.renderers import JSONRenderer
from rest_framework.parsers import JSONParser
from rest_framework import status
from rest_framework.decorators import api_view
from rest_framework.response import Response
from tabla_propiedades.models import Tabla_Propiedades
from tabla_propiedades.serializers import *
class JSONResponse(HttpResponse):
    """
    An HttpResponse that renders it's content into JSON.
    """
    def __init__(self, data, **kwargs):
        content = JSONRenderer().render(data)
        kwargs['content_type'] = 'application/json'
        super(JSONResponse, self).__init__(content, **kwargs)

#---Metodo para Modelo
@csrf_exempt
def tablapropiedades_list(request):
    if request.method == 'GET':
        actividades = Tabla_Propiedades.objects.all()
        serializer = TablaPropiedadesSerializer(actividades, many=True)
        response={}
        total={}
        response['status']=0
        response['totalRows']=len(actividades)
        response['startRow']=0
        response['endRow']=len(actividades)-1
        response['data']=serializer.data
        total['response']=response
        return JSONResponse(total)
    elif request.method == 'POST':
        actividades = Tabla_Propiedades.objects.all()
        serializer = TablaPropiedadesSerializer(actividades, many=True)
        response={}
        total={}
        response['status']=0
        response['totalRows']=len(actividades)
        response['startRow']=0
        response['endRow']=len(actividades)-1
        response['data']=serializer.data
        total['response']=response
        return JSONResponse(total)

@csrf_exempt
def tablapropiedades_ingresa(request):
    if request.method == 'GET':
        nombre = request.GET.get('nombre')
        valor = request.GET.get('valor')
        a=Tabla_Propiedades(nombre=nombre,valor=valor) 
        a.save() 
        actividades = Tabla_Propiedades.objects.get(id_tabla_propiedades=a.id_tabla_propiedades)
        serializer = TablaPropiedadesSerializer(actividades)
        response={}
        total={}
        response['status']=0
        response['totalRows']=1
        response['startRow']=0
        response['endRow']=0
        response['data']=serializer.data
        total['response']=response
        return JSONResponse(total)
    if request.method == 'POST':
        nombre = request.POST.get('nombre')
        valor = request.POST.get('valor')
        a=Tabla_Propiedades(nombre=nombre,valor=valor) 
        a.save() 
        actividades = Tabla_Propiedades.objects.get(id_tabla_propiedades=a.id_tabla_propiedades)
        serializer = TablaPropiedadesSerializer(actividades)
        response={}
        total={}
        response['status']=0
        response['totalRows']=1
        response['startRow']=0
        response['endRow']=0
        response['data']=serializer.data
        total['response']=response
        return JSONResponse(total)

@csrf_exempt
def tablapropiedades_actualiza(request):
    if request.method == 'GET':
        id_tabla_propiedades = request.GET.get('id_tabla_propiedades')
    	nombre = request.GET.get('nombre')
        valor = request.GET.get('valor')
        actividades = Tabla_Propiedades.objects.get(id_tabla_propiedades=id_tabla_propiedades)
        actividades.nombre = nombre
        actividades.valor = valor
        actividades.save()
        serializer = TablaPropiedadesSerializer(actividades)
        response={}
        total={}
        response['status']=0
        response['totalRows']=1
        response['startRow']=0
        response['endRow']=0
        response['data']=serializer.data
        total['response']=response
        return JSONResponse(total)
    if request.method == 'POST':
    	id_tabla_propiedades = request.POST.get('id_tabla_propiedades')
    	nombre = request.POST.get('nombre')
        valor = request.POST.get('valor')
        actividades = Tabla_Propiedades.objects.get(id_tabla_propiedades=id_tabla_propiedades)
        actividades.nombre = nombre
        actividades.valor = valor
        actividades.save()
        serializer = TablaPropiedadesSerializer(actividades)
        response={}
        total={}
        response['status']=0
        response['totalRows']=1
        response['startRow']=0
        response['endRow']=0
        response['data']=serializer.data
        total['response']=response
        return JSONResponse(total)

@csrf_exempt
def tablapropiedades_elimina(request):
    if request.method == 'GET':
        id_tabla_propiedades = request.GET.get('id_tabla_propiedades')
        work = Tabla_Propiedades.objects.get(id_tabla_propiedades=id_tabla_propiedades)
        work.delete()
        borro={}
        devuelve={}
        borro['id_workflow']=id_tabla_propiedades
        devuelve['response']=borro
        return JSONResponse(devuelve)
    if request.method == 'POST':
        id_tabla_propiedades = request.POST.get('id_tabla_propiedades')
        work = Tabla_Propiedades.objects.get(id_tabla_propiedades=id_tabla_propiedades)
        work.delete()
        borro={}
        devuelve={}
        borro['id_workflow']=id_tabla_propiedades
        devuelve['response']=borro
        return JSONResponse(devuelve)